<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class ParamGeraisService {

	public function __construct(EntityManager $entityManager) {
		$this->entityManager = $entityManager;
	}
	
	public function getContrato($params) {
		$NRORG = array('NRORG'=>$params['NRORG']);
		$hex = $this->entityManager->getConnection()->fetchAll(self::FETCH_CONTRATO, $NRORG);
		return $hex;
	}
	
	public function saveContrato($params){
		$NRORG = array('NRORG'=>$params[0]['NRORG']);
		$nrContratos = $this->entityManager->getConnection()->fetchAll(self::COUNT_CONTRATO, $NRORG);
		$conditions = array(
			'DSCONTRATOGERAL' => $params[0]['DSCONTRATOGERAL'],
			'DTULTATU'		  => $params[0]['DTINCLUSAO'],
			'CDOPERINCLUSAO'  => $params[0]['CDOPERINCLUSAO'],
			'CDCONTRATOGERAL' => $params[0]['CDCONTRATOGERAL'],
			'NRORG'		      => $params[0]['NRORG']
		);
		if($nrContratos[0]['QUANTIDADE'] == 0){
			return $this->entityManager->getConnection()->executeQuery(self::INSERT_CONTRATO, $conditions);
		} else {
			return $this->entityManager->getConnection()->executeQuery(self::UPDATE_CONTRATO, $conditions);
		}
	}
	
	const COUNT_CONTRATO = "SELECT COUNT(*) AS QUANTIDADE FROM CONTRATOGERAL WHERE NRORG = :NRORG";
	
	const INSERT_CONTRATO = "
		INSERT INTO CONTRATOGERAL
		  (CDCONTRATOGERAL, DSCONTRATOGERAL)
		VALUES
		  ('0001', UTL_RAW.CAST_TO_RAW(:DSCONTRATOGERAL))
	";
	
	const UPDATE_CONTRATO = "
		UPDATE CONTRATOGERAL
		SET DSCONTRATOGERAL = UTL_RAW.CAST_TO_RAW(:DSCONTRATOGERAL),
			DTINCLUSAO = :DTULTATU,
			CDOPERINCLUSAO = :CDOPERINCLUSAO 
		WHERE CDCONTRATOGERAL = '0001'
		   AND NRORG = :NRORG
	";
	
	const FETCH_CONTRATO = "
		SELECT DSCONTRATOGERAL, CDCONTRATOGERAL, NRORG
		FROM CONTRATOGERAL
		WHERE NRORG = :NRORG
	";
}